/* -*-c-*-
 *
 *  $Id: main.c,v 1.4 2004/10/28 00:59:56 scip Exp $
 * 
 *  This file  is  part of the  MD5PW  password  generator  tool.
 *
 *  By  accessing  this software,  MD5PW, you  are  duly informed
 *  of and agree to be  bound by the  conditions  described below
 *  in this notice:
 *
 *  This software product,  MD5PW,  is developed by Thomas Linden
 *  and   copyrighted (C) 1999-2002   by  Thomas Linden, with all
 *  rights reserved.
 *
 *  There  is no charge for MD5PW software.  You can redistribute
 *  it and/or modify it under the terms of the GNU General Public
 *  License, which is incorporated by reference herein.
 *
 *  MD5PW is distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS,
 *  OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that
 *  the use of it will not infringe on any third party's intellec-
 *  tual property rights.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with MD5PW.  Copies can also be obtained from:
 *
 *    http://www.gnu.org/copyleft/gpl.html
 *
 *  or by writing to:
 *
 *  Free Software Foundation, Inc.
 *  59 Temple Place, Suite 330
 *  Boston, MA 02111-1307
 *  USA
 *
 *  Or contact:
 *
 *   "Thomas Linden" <tom@daemon.de>
 *
 *
 */


#include "main.h"



int main(int argc, char **argv ) {
  char *pass;
  char *src;
  char *reverse;
  char *dst;
  int i, x;
  int len, passlen, arglen;

  if(argc == 2) {
    pass = NULL;
    if(isatty(0) == 1) {
      pass = read_passphrase("passphrase: ", pass);
    }
    else {
      pass = (char *)xmalloc(1024);
      scanf("%s", pass);
    }
    passlen = strlen(pass);
    arglen  = strlen(argv[1]);

    /* concat the hostname(src) and the passphrase */
    src = (char *)xmalloc(passlen + arglen);
    src[0] = '\0';
    src = strcat(src, pass);
    src = strcat(src, argv[1]);
    free(pass);

    /* do the digest, cut it from behind and reverse this */
    len = atoi(PASSWD_LEN);
    reverse = (char *)xmalloc((size_t)len);
    dst = (char *)xmalloc(33);
    dst = md5_binary(src, strlen(src));
    x=0;
    for(i=len; i != 0; i--) {
      reverse[x] = dst[strlen(dst)-i];
      x++;
    }

    /* print it out using terminal escape sequences to hide it on the monitor */
    reverse[x] = '\0';
    if(isatty(1))
      printf("%s%s%s\n", HIDECOLOR, reverse, DEFAULTCOLOR);
    else
      printf("%s\n", reverse);
  }
  else {
    printf("usage: md5pw <hostname>\n");
  }
  
  return 1;
}


