/* -*-c-*-
 *
 *  $Id: md5.h,v 1.2 2002/07/20 23:35:46 scip Exp $
 * 
 *  This file  is  part of the  MD5PW  password  generator  tool.
 *
 *  By  accessing  this software,  MD5PW, you  are  duly informed
 *  of and agree to be  bound by the  conditions  described below
 *  in this notice:
 *
 *  This software product,  MD5PW,  is developed by Thomas Linden
 *  and   copyrighted (C) 1999-2002   by  Thomas Linden, with all
 *  rights reserved.
 *
 *  There  is no charge for MD5PW software.  You can redistribute
 *  it and/or modify it under the terms of the GNU General Public
 *  License, which is incorporated by reference herein.
 *
 *  MD5PW is distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS,
 *  OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that
 *  the use of it will not infringe on any third party's intellec-
 *  tual property rights.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with MD5PW.  Copies can also be obtained from:
 *
 *    http://www.gnu.org/copyleft/gpl.html
 *
 *  or by writing to:
 *
 *  Free Software Foundation, Inc.
 *  59 Temple Place, Suite 330
 *  Boston, MA 02111-1307
 *  USA
 *
 *  Or contact:
 *
 *   "Thomas Linden" <tom@daemon.de>
 *
 *
 */


#ifndef MD5_H
#define MD5_H

#ifdef uint32_t
#define u_int32_t uint32_t
#endif

struct MD5Context {
	u_int32_t buf[4];
	u_int32_t bits[2];
	unsigned char in[64];
};

void MD5Init(struct MD5Context *context);
void MD5Update(struct MD5Context *context, unsigned char const *buf,
	       unsigned len);
void MD5Final(unsigned char digest[16], struct MD5Context *context);
void MD5Transform(u_int32_t buf[4], u_int32_t const in[16]);

/*
 * This is needed to make RSAREF happy on some MS-DOS compilers.
 */
typedef struct MD5Context MD5_CTX;

#endif /* !MD5_H */
